import { CatCode } from './enums/catcode';
import { GroupType } from './enums/group-type';
import Command from './modules/commands/command';
import { Trie } from './utils/trie';
export default class Context {
    #private;
    groupType: GroupType;
    depth: number;
    parent?: Context | undefined;
    static primitives: Trie<[cmd: number, chr: string] | null>;
    eqtb: {
        catcode: Uint8Array | number[];
    };
    reset: boolean;
    command: Command | null;
    constructor(groupType: GroupType);
    constructor(groupType: GroupType, depth: number, parent: Context);
    get hash(): number;
    defineCatCode(chr: number, cmd: number): void;
    getCatCode(ch: number): CatCode;
    private generateEqTbHash;
    private generateHash;
}
