import { Parser } from "lezer";
import { tokenizer, trackContext } from "../tokens";
import { NodeProp } from "lezer";
const spec_other_char = { __proto__: null, 0: 123, 1: 123, 2: 123, 3: 123, 4: 123, 5: 123, 6: 123, 7: 123, 8: 123, 9: 125, "=": 111, "+": 119, "-": 119, "'": 127, "\"": 129, A: 133, B: 133, C: 133, D: 133, E: 133, F: 133, "`": 139 };
const spec_letter = { __proto__: null, A: 135, B: 135, C: 135, D: 135, E: 135, F: 135 };
export const parser = Parser.deserialize({
    version: 13,
    states: "4^OVQQOOO!jQQO'#D`OOQQ'#Ci'#CiO!qQQO'#DaOOQQ'#Cl'#ClOVQQO'#DbOVQQO'#DcOOQQ'#Ck'#CkOOQQ'#Cn'#CnOOQQ'#Cx'#CxO!xQQO'#DgOOQQ'#Co'#CoOOQQ'#Cp'#CpO#ZQQO'#DdOOQQ'#Cr'#CrO#ZQQO'#DfOOQQ'#Cs'#CsO#cQQO'#DgOOQQ'#Ct'#CtO#hQRO'#DhOOQQ'#Cv'#CvOOQQ'#D_'#D_OOQQ'#Cw'#CwQVQQOOOOQQ,59z,59zO$PQQO,59zOOQQ'#Cj'#CjOOQQ,59{,59{O!qQQO,59{POQQ,59X,59XOOQQ,59|,59|OVQQO,59|OOQQ,59},59}OVQQO,59}OOQQ-E6v-E6vO#ZQQO,5:OO#ZQQO,5:QO#cQQO,5:RO#hQRO,5:SOOQQ'#Cy'#CyO#ZQQO,5:OO$WQRO,5:OO#ZQQO,5:QO#ZQQO,5:QOOQQ,5:R,5:RO#hQRO,5:SO$cQRO'#CuOOQQ'#Dj'#DjOOQQ'#C{'#C{OOQQ'#Cu'#CuO$wQQO'#DrO%uQRO,5:SOOQQ'#Cz'#CzO&aQRO'#CuO&fQRO'#CuOOQQ-E6u-E6uOOQQ1G/f1G/fOOQQ1G/g1G/gOOQQ1G/h1G/hOOQQ1G/i1G/iO#ZQQO1G/jO$WQRO1G/jO#ZQQO1G/lO#ZQQO1G/lOOQQ1G/m1G/mO#hQRO1G/nO%uQRO1G/nOOQQ-E6w-E6wO$WQRO1G/jOOQQ'#Cq'#CqOOQQ1G/j1G/jO#ZQQO1G/jO#ZQQO1G/lO#ZQQO1G/lOOQQ-E6x-E6xOOQQ,59a,59aO&aQRO,59aO&fQRO,59aOOQQ-E6y-E6yOOQQ'#Dt'#DtOOQQ,5:^,5:^O%uQRO1G/nO&tQRO'#CuOOQQ1G/n1G/nO(hQRO1G/nOOQQ'#C|'#C|OOQQ'#Do'#DoOOQQ'#C}'#C}O)PQRO,59aO$WQRO7+%UO$WQRO7+%UOOQQ7+%U7+%UO#ZQQO7+%UO#ZQQO7+%WO#ZQQO7+%WO#ZQQO7+%WO%uQRO7+%YO%uQRO7+%YOOQQ7+%Y7+%YO(hQRO7+%YO#ZQQO7+%UO#ZQQO7+%WOOQQ7+%W7+%WOOQQ1G.{1G.{O)qQRO1G.{O*cQRO,59aO(hQRO7+%YO,VQRO,59aOOQQ-E6z-E6zOOQQ-E6{-E6{O$WQRO<<HpOOQQ<<Hp<<HpO#ZQQO<<HpO#ZQQO<<HpO#ZQQO<<HrO#ZQQO<<HrO#ZQQO<<HrOOQQ<<Hr<<HrO%uQRO<<HtOOQQ<<Ht<<HtO(hQRO<<HtO(hQRO<<HtO-zQRO1G.{OOQQAN>[AN>[O#ZQQOAN>[O#ZQQOAN>[O#ZQQOAN>^O#ZQQOAN>^OOQQAN>^AN>^OOQQAN>`AN>`O(hQROAN>`O(hQROAN>`O#ZQQOG23vOOQQG23vG23vO#ZQQOG23xOOQQG23xG23xO(hQROG23zOOQQG23zG23zOOQQLD)bLD)bOOQQLD)dLD)dOOQQLD)fLD)fO.RQRO'#CuO&aQRO'#CuO&aQRO,59aO.gQRO,59aO.qQRO1G.{O&fQRO'#CuO&fQRO,59a",
    stateData: "/T~O!POS~OPPORSOSeOTeOUeOVeOWeOXeOYeOZeOseOteOueOv[OwQOybOz`O{ZO|^O}WO!OdO~OQhO~PVOxjO~PVOybOz`O{ZO|^O}WO~OswOv[O~OPPO~OswO!]!UO!_!PO!`!PO!a!VO!b!WO!g!SO~OQ!YO~PVOswOv[O!X!gO~O!]!UO!_!PO!`!PO!a!nO!b!oO!g!SO~OP!qOQ!qOR!qOS!qOT!qOU!qOV!qOW!qOX!qOY!rOZ!qOt!qOu!qOv[O~OswO!X!gO!]!UO!_!PO!`!PO!a$SO!b$WO!g!SO~O!_!wO~O!_!PO!`!PO!d!xO!e!xO~O!_!PO!`!POPiXRiXSiXTiXUiXViXWiXXiXYiXZiXriXsiXtiXuiXviXwiXyiXziX{iX|iX}iX!OiXQiXxiX~OswO!]!UO!_!PO!`!PO!a$SO!b$WO!g!SO~O!d!xO!e!xOsia!Xia!]ia!_ia!`ia!aia!bia!gia~O!d!xO!e!xOsii!Xii!]ii!_ii!`ii!aii!bii!gii~O!_!PO!`!POPiaRiaSiaTiaUiaViaWiaXiaYiaZiariasiatiauiaviawiayiazia{ia|ia}ia!OiaQiaxia~O!_!wO~P*iOPiiRiiSiiTiiUiiViiWiiXiiYiiZiiriisiitiiuiiviiwiiyiizii{ii|ii}ii!OiiQiixii~O!_!wO~P,^O!]!UO!_!PO!`!PO!a$TO!b$XO!g!SO~O!d!xO!e!xO~P*cO!_!PO!`!PO!d!xO!e!xO~P,^O!O~",
    goto: "0h!iPPPPPPPPPPPPP!j!v!|#Y#j#z$X$h&i'V'f'u(U!|(z)b)q,T,o-a-qPPPPPPPPPPPPPPP.T.a!|.s.s!|P!|!|!|P/PPPPP/qPP/{P0eeROPRTUgiloqQkRR!ZleeOPRTUgiloq`TOPRUgilqQnTR![o`UOPRTgiloQpUR!]qgXOPRTUYgiloqd]OPRTUgiloqRsYdeOPRTUgiloqQy]Q{_S!_sxS!atzQ!hyQ!k{Q!r!SQ!{!^U!}!_!f!iQ#P!`S#R!a!jQ#Y!kW#c!{!|#O#WS#g#P#QS#i#R#XU#o#b#d#eQ#r#fS#t#g#hS#y#p#qS#{#r#sQ$O#xR$P#zQ!iyQ!v!TS#O!_!fS#V!d!sS#d!{!|S#l#S#TQ#p#bR#v#jd_OPRTUgiloqRtYdaOPRTUgiloqRuYdcOPRTUgiloqRvYQ!TcS!dv}Q!u!TQ#S!cU#U!d!s!vW#k#S#T#V#^U#u#j#l#mS#}#v#wR$Q#|QgOQiPQlRQoTQqUZ!XgiloqdYOPRTUgiloqRrYQx]Qz_Q}cQ!^sQ!`tQ!cv!W!exz}!^!`!c!f!j!s!|#Q#T#W#X#^#b#e#f#h#j#m#q#s#w#x#z#|Q!fyQ!j{Q!s!TQ!|!_Q#Q!aQ#T!dQ#W!iQ#X!kQ#^!vQ#b!{Q#e#OQ#f#PQ#h#RQ#j#SQ#m#VQ#q#dQ#s#gQ#w#lQ#x#pQ#z#rR#|#vW!Ocv}!cS!l!O$Rm$R!T!d!s!v#S#T#V#^#j#l#m#v#w#|W!Rcv}!cQ!m!OS!p!t#]l!t!T!d!s!v#S#T#V#^#j#l#m#v#w#|R#]$RQ!m!VQ#Z!nQ#_$SS#`#_#nR#n$TQ!z!WQ#[!oW#a!z#[$U$VQ$U$WR$V$XefOPRTUgiloqdeOPRTUgiloqQ|aR!bueVOPRTUgiloq|!Qcv}!O!T!c!d!s!t!v#S#T#V#]#^#j#l#m#v#w#|$R]!x!W!o$U$V$W$Xa!y!W!o!z#[$U$V$W$Xt!Rcv}!T!c!d!s!v#S#T#V#^#j#l#m#v#w#|T!m!O$RR!r!S",
    nodeNames: "⚠ left_brace right_brace math_shift tab_mark car_ret mac_param sup_mark sub_mark ignore active_char invalid_char Document begingroup_cs endgroup_cs math_shift_group single_math_shift double_math_shift prefix_cs let_cs control_sequence optional_equal futurelet_cs def_cs defcode_cs integer directive",
    maxTerm: 70,
    context: trackContext,
    nodeProps: [
        [NodeProp.closedBy, 1, "right_brace", 16, "single_math_shift", 17, "double_math_shift"],
        [NodeProp.openedBy, 2, "left_brace", 16, "single_math_shift", 17, "double_math_shift"]
    ],
    skippedNodes: [0],
    repeatNodeCount: 7,
    tokenData: "RORO",
    tokenizers: [0, tokenizer],
    topRules: { "Document": [0, 12] },
    dialects: { directives: 647 },
    specialized: [{ term: 37, get: value => spec_other_char[value] || -1 }, { term: 36, get: value => spec_letter[value] || -1 }],
    tokenPrec: 0,
    termNames: { "0": "⚠", "1": "left_brace", "2": "right_brace", "3": "math_shift", "4": "tab_mark", "5": "car_ret", "6": "mac_param", "7": "sup_mark", "8": "sub_mark", "9": "ignore", "10": "active_char", "11": "invalid_char", "12": "@top", "13": "begingroup_cs", "14": "endgroup_cs", "15": "math_shift_group", "16": "single_math_shift", "17": "double_math_shift", "18": "prefix_cs", "19": "let_cs", "20": "control_sequence", "21": "optional_equal", "22": "futurelet_cs", "23": "def_cs", "24": "defcode_cs", "25": "integer", "26": "directive", "27": "statement+", "28": "prefix_cs+", "29": "spacer+", "30": "sign+", "31": "dec_digit+", "32": "oct_digit+", "33": "hex_digit+", "34": "␄", "35": "spacer", "36": "letter", "37": "other_char", "38": "control_sequence_token", "39": "begingroup_cs_token", "40": "endgroup_cs_token", "41": "defcode_cs_token", "42": "def_cs_token", "43": "let_cs_token", "44": "futurelet_cs_token", "45": "prefix_cs_token", "46": "directive_comment", "47": "line_comment", "48": "%mainskip", "49": "statement", "50": "simple_group", "51": "semi_simple_group", "52": "ordinary_math_mode", "53": "display_math_mode", "54": "let_cmd", "55": "other_char/\"=\"", "56": "futurelet_cmd", "57": "def_cmd", "58": "defcode_cmd", "59": "other_char/\"+\"", "60": "dec_digit", "61": "other_char/\"0\"", "62": "other_char/\"9\"", "63": "other_char/\"'\"", "64": "other_char/\"\\\"\"", "65": "hex_digit", "66": "other_char/\"A\"", "67": "letter/\"A\"", "68": "alpha_number", "69": "other_char/\"`\"", "70": "any_char" }
});

//# sourceMappingURL=parser.js.map
