import cp from '../../utils/c';
import Command from './command';
function parseInteger(value) {
    const typ = value.codePointAt(0);
    const val = value.slice(1);
    switch (typ) {
        case cp `\``: {
            let v = val.codePointAt(0);
            if (v === cp `\\`) {
                v = val.codePointAt(1);
            }
            return v;
        }
        case cp `"`:
            return parseInt(val, 16);
        case cp `'`:
            return parseInt(val, 8);
        default:
            return parseInt(value, 10);
    }
}
export class CatCodeCommand extends Command {
    exec(ctx, charInt, catCodeInt) {
        ctx.defineCatCode(parseInteger(charInt), parseInteger(catCodeInt));
        return ctx;
    }
}

//# sourceMappingURL=index.js.map
