export default class Directive {
    constructor({ test, run, fallthrough }) {
        this.test = test;
        this.run = run;
        this.fallthrough = !!fallthrough;
    }
    exec(directive, context) {
        const args = this.test(directive);
        if (!args)
            return null;
        return this.run(context, ...args);
    }
}

//# sourceMappingURL=directive.js.map
