export class Trie {
    constructor(v) {
        this.v = v;
        this.children = [];
    }
    insert(k, v) {
        let n = this;
        for (const p of Uint32Array.from(k, (s) => s.codePointAt(0)).reverse()) {
            if (n.children[p] === undefined)
                n.children[p] = new Trie(n.v);
            n = n.children[p];
        }
        n.v = v;
    }
    lookup(k) {
        let n = this;
        for (const p of Uint32Array.from(k, (s) => s.codePointAt(0)).reverse()) {
            n = n.children[p];
            if (n === undefined)
                return null;
        }
        return n.v;
    }
}

//# sourceMappingURL=trie.js.map
